package lt.bit.SauktiniuSarasas.restControllers;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PatchMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import lt.bit.SauktiniuSarasas.entities.Sauktinis;
import lt.bit.SauktiniuSarasas.services.SauktiniaiService;

@RestController
@RequestMapping("/sauktiniai")
public class SauktiniaiController {
	@Autowired
	SauktiniaiService sauktiniaiService;
	
	@CrossOrigin
	@GetMapping("/")
	public List<Sauktinis> index() throws InterruptedException{
		Thread.sleep(1000+(int)(Math.random()*3000));
		return sauktiniaiService.getSauktiniai();
	}
	
	@CrossOrigin
	@PostMapping("/")
	public Sauktinis add(@RequestBody Sauktinis s ){
		return sauktiniaiService.saveSauktinis(s);
	}
	
	@CrossOrigin
	@GetMapping("/{id}")
	public Sauktinis get(@PathVariable Integer id) {
		return sauktiniaiService.getSauktinis(id);
	}
	
	@CrossOrigin
	@PatchMapping("/{id}")
	public Sauktinis update(@PathVariable Integer id, @RequestBody Sauktinis s) {
		return sauktiniaiService.updateSauktinis(s);
	}
	
	@CrossOrigin
	@DeleteMapping("/{id}")
	public Boolean delete(@PathVariable Integer id) {
		 sauktiniaiService.deleteSauktinis(id);
		 return true;
	}
	

}
